# Developer Tools

### Testnet Tokens

For testnet tokens, you can use this faucet: <https://faucet.findora.org/>. Feel free to reach out to the team with any questions or issues. Once you claim testnet FRA, you can bridge it to the GSC testnet using <https://anvil.rialtobridge.io/>.&#x20;

### RanDAO&#x20;

[RandDAO](https://github.com/randao/randao) is a decentralized application aiming to generate verifiable random numbers on the blockchain.&#x20;

Developers can initiate a random number task through the ‘newCampaign()’ function, specifying parameters that dictate the target block for generation, deposit amounts, and commit timelines. Once initiated, participants must commit and reveal their random numbers within defined timeframes. The generated random number can be retrieved using the ‘getRandom()’ function, after the target block is reached. However, if the retrieval fails for reasons such as not reaching the target block or non-compliance by participants, rewards can be returned using the ‘refundBounty()’ function.

For more info on using RanDAO's contracts, see their documentation: <https://github.com/randao/randao/blob/master/handbook.md>&#x20;

### RanDAO Contract Address on GSC

<table data-header-hidden><thead><tr><th width="204"></th><th></th></tr></thead><tbody><tr><td>GSC Testnet</td><td><p>0xfB45f8B9705FFA9d05D42b72E73afE7E2ceEa860</p><p><br></p></td></tr><tr><td>GSC Mainnet</td><td>0x0419c41d9a24f8f6B8d190CAf2C5C8254A1ae2D9</td></tr></tbody></table>

### The ZkGaming SDK

Findora card game SDK is an all-purpose tool set that enables game developers to easily build on-chain games using zero-knowledge proof technology. Learn more in its GitHub repo: <https://github.com/FindoraNetwork/zkcard-mini-sdk>

### Graph Node on Findora's GSC

**Mainnet:** <https://gsc-mainnet.graph.findora.org/subgraphs>&#x20;

**Testnet:** <https://gsc-testnet.graph.findora.org/subgraphs>&#x20;

<br>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.findora.org/developers/game-specific-chains/developer-tools.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
